#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <time.h>

#include "forms.h"
#include "testgui.h"
#include "serverglobals.h"

extern char callsign[], name[], location[], password[];

extern *userServer;


struct entry *addEntryList(struct entry *, struct stationData *);
struct entry *flushEntryList(struct entry *);
int printList(struct entry *);

struct stationData  *station;
struct entry        *linkHead, *repeaterHead, *confHead, *stationHead;
struct entry        *messageHead, *listHead;

/************************/
/**** Open a socket *****/

int  openSocket(char *srvr_addr){

  int  sck, z;
  struct sockaddr_in adr_srvr;/* AF_INET */
  int len_inet;               /* length  */
  struct hostent *hp;
  char *addr;

  hp = gethostbyname(srvr_addr);

  if(hp){
    addr = inet_ntoa(*(struct in_addr *)hp->h_addr_list[0]);
    //     // printf("IP address for %s is %s..\n", argv[1], 
    //     inet_ntoa(*(struct in_addr *)hp->h_addr_list[0]));
    //printf("IP address for %s is %s..\n", argv[1],
    //     srvr_addr);
 
  } else {
    return(-1);
  }
  memset(&adr_srvr,0,sizeof adr_srvr);
  adr_srvr.sin_family = AF_INET;
  adr_srvr.sin_port = htons(5200);
  adr_srvr.sin_addr.s_addr =
    inet_addr(addr);

  if ( adr_srvr.sin_addr.s_addr == INADDR_NONE )
    return(-1);

  len_inet = sizeof adr_srvr;

  /*
   * Create a TDP/IP socket to use :
   */
  sck = socket(PF_INET,SOCK_STREAM,0);
  if ( sck == -1 )
    return(sck);
    
  /*
   * Connect to the server:
   */
 // printf("attempting to connect to %s.\n", srvr_addr);
 
  z = connect(sck, (struct sockaddr *) &adr_srvr,len_inet);
    if ( z == -1 ){
    close(sck);
    return(-1);
    }

 // printf("Connection a success!!!\n");

  return(sck);

}

/************************************/

int sendLogon(char *srvr_addr){

  struct tm *tm_ptr;
  time_t    theTime;
  char      logTime[6];
  unsigned char    sendBuf[50], recvBuf[50];
  int     i, s, z, result;

  /* Now send the 'l' command */

 // printf("Attempting to log on to %s.\n", srvr_addr);

  s = openSocket(srvr_addr);
  if(s < 0)
    return(0);
 // printf("Socket = %d.\n", s);
 // printf("Send the 'l' command.\n");
  memset(sendBuf, 0x6c, 1);
  result = write(s, sendBuf, 1);
 // printf("Wrote %d bytes.\n", result);

  /* Get the local time */
  (void) time(&theTime);
  tm_ptr = localtime(&theTime);
  strftime(logTime, 6, "%H:%M", tm_ptr);

  strcpy(sendBuf, callsign);
  strcat(sendBuf,"\254\254");
  //puts(sendBuf);
  strcat(sendBuf, password);
  strcat(sendBuf, "\015ONLINE3.38(");
  strcat(sendBuf, logTime);
  // puts(sendBuf);
  strcat(sendBuf, ")\015");
  strcat(sendBuf,location);
  strcat(sendBuf,"\015");
  /*
  puts(sendBuf);
  for(i=0;i<strlen(sendBuf);i++){
   printf("%02x ", sendBuf[i]);
  }
  printf("\n");
  */

  result = write(s, sendBuf, strlen(sendBuf));
 // printf("Sent %d bytes.\n", result);

  result = read(s, recvBuf, 50);
  if(result < 0){
    perror(" Receive ");
    return(0);
  }
  else {
 // printf("Received %d bytes.\n", result);
    // for(i = 0;i<result;i++)
   // printf("%02x ", recvBuf[i]);
 // printf("\n");
  }

  close(s);
  return(1);

}

/************************************/

int sendLogoff(char *srvr_addr){

  unsigned char    sendBuf[50], recvBuf[50];
  int     i, s, result;

  s = openSocket(srvr_addr);
  if(s<0)
    return(0);

 // printf("Socket = %d.\n", s);

  /* Now send the 'l' command */
 // printf("Send the 'l' command.\n");
  memset(sendBuf, 0x6c, 1);
  result = write(s, sendBuf, 1);
 // printf("Wrote %d bytes.\n", result);

  strcpy(sendBuf, callsign);
  strcat(sendBuf,"\254\254");
  strcat(sendBuf, password);
  strcat(sendBuf,"\015OFF-V3.40\015");
  strcat(sendBuf, location);
  strcat(sendBuf, "\015");
  for(i=0;i<strlen(sendBuf);i++){
   // printf("%02x ", sendBuf[i]);
  }
 // printf("\n");

  result = write(s, sendBuf, strlen(sendBuf));
 // printf("Sent %d bytes.\n", result);

  /* Now get the result */
  result = read(s, recvBuf, 50);
  if(result < 0){
    perror(" Receive ");
    return(0);
  }
  else {
 // printf("Received %d bytes.\n", result);
    //for(i = 0;i<result;i++)
   // printf("%02x ", recvBuf[i]);
 // printf("\n");
  }

  close(s);
  return(1);

}
/************************************/

int makeMeBusy(char *srvr_addr){

  struct tm *tm_ptr;
  time_t    theTime;
  char      logTime[6];
  unsigned char    sendBuf[50], recvBuf[50];
  int     i, s, result;

  s = openSocket(srvr_addr);
  if(s<0)
    return(0);
 // printf("Socket = %d.\n", s);

  /* Now send the 'l' command */
 // printf("Send the 'l' command.\n");
  memset(sendBuf, 0x6c, 1);
  result = write(s, sendBuf, 1);
 // printf("Wrote %d bytes.\n", result);

  /* Get the local time */
  (void) time(&theTime);
  tm_ptr = localtime(&theTime);
  strftime(logTime, 6, "%H:%M", tm_ptr);

  strcpy(sendBuf, callsign);
  strcat(sendBuf,"\254=");
  strcat(sendBuf, password);
  strcat(sendBuf,"\015BUSY3.40(");
  strcat(sendBuf, logTime);
  strcat(sendBuf, ")\015");
  strcat(sendBuf,location);
  strcat(sendBuf,"\015");
  for(i=0;i<strlen(sendBuf);i++){
   // printf("%02x ", sendBuf[i]);
  }
 // printf("\n");

  result = write(s, sendBuf, strlen(sendBuf));
 // printf("Sent %d bytes.\n", result);

  /* Now get the result */
  result = read(s, recvBuf, 50);
  if(result < 0){
    perror(" Receive ");
    return(0);
  }
  else {
 // printf("Received %d bytes.\n", result);
    //for(i = 0;i<result;i++)
   // printf("%02x ", recvBuf[i]);
 // printf("\n");
  }

  close(s);
  return(1);

}

/************* find end of list **********/

struct entry *findEnd(struct entry *list){

  struct entry *temp;

  if(list == NULL){ 
    return(NULL);
  }

  temp = list;
  while(temp->next != NULL){
    temp = temp->next;
  }

  return(temp);
}

/***** Get calls function **********/

int getCalls(char *srvr_addr){

  int  s, result, i, j, numRecs;
  unsigned char sendBuf[10], recvBuf[2000];
  char *ptr, *eptr;
  char temp[4][80];
  FILE *tx, *rx;
  struct entry *last;

  s = openSocket(srvr_addr);
 // printf("Socket = %d.\n", s);

  rx = fdopen(s, "r");
  if(rx ==NULL){
    perror("Openning rx stream");
    close(s);
    return(-1);
  }

  tx = fdopen(dup(s), "w");
  if(tx == NULL){
    perror("Openning tx stream");
    fclose(rx);
    return(-1);
  }

  /* Now send the 's' command */
 // printf("Send the 's' command.\n");
  result = fputc('s', tx);
  if(result < 0){
    perror(" Send the s command ");
    fclose(tx);
    fclose(rx);
    return(-1);
  }
 // printf("Wrote %d bytes.\n", result);
  fflush(tx);

  /* Now read the response */
  result = fscanf(rx, "%s\n", temp[0]);
 // printf("Read %d chars: %s\n", result, temp[0]);

  /* Now get the number of following records */

  result = fscanf(rx, "%d\n", &numRecs);
 // printf("Number of records = %d.\n", numRecs);

  /**
  stationHead = flushEntryList(stationHead);
  linkHead = flushEntryList(linkHead);
  repeaterHead = flushEntryList(repeaterHead);
  confHead = flushEntryList(confHead);
  messageHead = flushEntryList(messageHead);
  ***/

  listHead = flushEntryList(listHead);

  for(i=0;i<numRecs;i++){
    station = malloc(sizeof (struct stationData));
  
    fgets(station->call, MAXCALL, rx);
    station->call[strlen(station->call)-1] = 0x00;
    fgets(station->data, MAXDATA, rx);
    station->data[strlen(station->data)-1] = 0x00;
    fgets(station->id, MAXID, rx);
    station->id[strlen(station->id)-1] = 0x00;
    fgets(station->ip, MAXIP, rx);
    station->ip[strlen(station->ip)-1] = 0x00;
   // printf("%-9s%-39s%6s %s\n", station->call, station->data,
    //   station->id, station->ip);

    if(strstr(station->call, "-L"))
      linkHead = addEntryList(linkHead, station);
    else if(strstr(station->call, "-R"))
      repeaterHead = addEntryList(repeaterHead, station);
    else if(strstr(station->call, "*"))
      confHead = addEntryList(confHead, station);
    else if(strlen(station->call) == 1)
      messageHead = addEntryList(messageHead, station);
     else 
       stationHead = addEntryList(stationHead, station);
    
    //    if(i % 10 == 0)
    //      getchar();
  }
 // printf("There are %d stations online.\n", numRecs);

  /**********
  printf("/nrepeaterHead = %p.\n", repeaterHead);
  printf("linkHead = %p.\n", linkHead);
  printf("stationHead = %p.\n", stationHead);
  printf("confHead = %p.\n", confHead);
  *************/

  fclose(tx);
  fclose(rx);
  close(s);


  listHead = repeaterHead;
  last = findEnd(listHead);
  last->next = linkHead;
  last = findEnd(repeaterHead);
  last->next = stationHead;
  last = findEnd(stationHead);
  last->next = confHead;
  last = findEnd(confHead);
  last->next = messageHead;
  messageHead = repeaterHead = NULL;
  linkHead = stationHead = confHead = NULL;

}

/******** Flush entry list *************/

struct entry *flushEntryList(struct entry *list){

  struct entry  *temp;
  int           counter;

  if(list == NULL)
    return(0);

  counter = 0;
  do{
    counter++;
    temp = list->next;
    if(list->station != NULL)
      free(list->station);
    free(list);
    list = temp;
  }while(list != NULL);
  return(NULL);
}

/******* Add to entry list ***********/

struct entry *addEntryList(struct entry *list, struct stationData *station){

  struct entry  *next, *previous, *temp;

  if(list == NULL){
    list = malloc(sizeof (struct entry));
    if(list != NULL){
      list->station = station;
      list->next = NULL;
    }
    return list;
  }

  previous = list;
  while(previous->next != NULL)
    previous = previous->next;
  temp= malloc(sizeof (struct entry));
  if(temp == NULL){
    perror(" Add entry malloc ");
    flushEntryList(list);
    return(NULL);
  }
  temp->station = station;
  temp->next = NULL;
  previous->next = temp;
  return(list);
}

/********* Print the list of pointers *****/

struct entry printPointers(struct entry *list){

  struct entry  *temp;

  temp = list;

  do{
   // printf("Pointer = %p.\n", temp);
    temp = temp->next;
  }while(temp != NULL);

}

/*********** Print stations list **********/

int printList(struct entry *list){

  int counter;
  char line[132];

  counter = 0;
  while(list != NULL){
    sprintf(line, "%-9s%-39s%6s %s", (list->station)->call,
	    (list->station)->data, (list->station)->id, (list->station)->ip);
    list = list->next;
    puts(line);
    // fl_add_browser_line(fd_servertest->callsList, line);
    counter++;
    /*********
    if(counter % 10 == 0){
     // printf("Hit return to continue.");
      getchar();
    }
    ***************/
  }

  return(counter);
}








